﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private htmlstring As String
End Sub
Public Sub Initialize
	htmlstring = ""
End Sub
Public Sub set_htmlpage(strtext As String,lang As String) As String
	If lang = "markup" Then
		strtext = strtext.Replace("&","&amp;")
		strtext = strtext.Replace("<","&lt;")
		strtext = strtext.Replace(">","&gt;")
	End If
	Private sb As StringBuilder
	sb.Initialize
	sb = html_header(sb,lang)
	sb = html_body(sb,lang,strtext)
	sb = html_footer(sb)
	htmlstring = sb.ToString
	Return htmlstring
End Sub
Private Sub html_header(sb As StringBuilder, lang As String) As StringBuilder
	Private HtmlCSS As String
	HtmlCSS = "table {font-family:helvetica;width: 98%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000; }" _
		& "th.sticky { position: -webkit-sticky; position: sticky; top:0; background-color: yellow; }" _
		& "body { padding:1px 1px 1px 1px;" _ 
		& " white-space: pre;" _
		& "	word-spacing: normal;" _
		& "	overflow: auto;" _
		& "	word-break: break-word;		/* normal; */" _
		& "	word-wrap: normal; }"
	sb.Append("<html>")
	sb.Append("<head>")
	sb.Append("<meta name='viewport' content='width=device-width, initial-scale=1'>")
	sb.Append("<style type='text/css'>").Append(HtmlCSS).Append("</style>").Append(CRLF)
	Private w3css As String
	w3css = set_w3css
	sb.Append("<style type='text/css'>").Append(w3css).Append("</style>").Append(CRLF)
	If lang = "b4x" Then
		Private prismcss As String
		prismcss = set_prism_css1
		sb.Append("<style type='text/css'>").Append(prismcss).Append("</style>").Append(CRLF)
		Private prismjs As String
		prismjs = set_prism_js1
		sb.Append("<script>").Append(prismjs).Append("</script>").Append(CRLF)
		prismcss = set_prism_css2
		sb.Append("<style type='text/css'>").Append(prismcss).Append("</style>").Append(CRLF)
		prismjs = set_prism_js2
		sb.Append("<script>").Append(prismjs).Append("</script>").Append(CRLF)
		prismjs = set_prism_js3
		sb.Append("<script>").Append(prismjs).Append("</script>").Append(CRLF)
	End If
	Return sb
End Sub
Private Sub html_body(sb As StringBuilder, lang As String, strtext As String) As StringBuilder
	'sb.Append("</head><body><pre><code class='language-" & lang & " line-numbers'>")
	sb.Append("</head><body><pre><code class='language-" & lang & "'>")
	'sb.Append(strtext).Append(CRLF)
	'Log("*" & strtext & "*")
	Dim lst As List = Regex.Split(Chr(10),strtext.Trim)
	'Log(lst)
	For i = 0 To lst.Size -1
		If i > 98 Then
			sb.Append(" ")
		Else if i > 8 Then
			sb.Append("  ")
		Else
			sb.Append("   ")
		End If
		sb.Append((i+1) & ". ").Append(lst.Get(i)).Append(CRLF)
	Next
	Return sb
End Sub
Private Sub html_footer(sb As StringBuilder) As StringBuilder
	sb.Append("</code></pre></body></html>")
	Return sb
End Sub
Private Sub set_prism_css1 As String
	Dim css As String
	css= File.ReadString(File.DirAssets,"prism.css")
	Return css
End Sub
Private Sub set_prism_css2 As String
	Dim css As String
	css= File.ReadString(File.DirAssets,"prism_b4x.css")
	Return css
End Sub
Private Sub set_prism_js1 As String
	Dim js As String
	js= File.ReadString(File.DirAssets,"prism.js")
	Return js
End Sub
Private Sub set_prism_js2 As String
	Dim js As String
	js= File.ReadString(File.DirAssets,"prism_b4x.js")
	Return js
End Sub
Private Sub set_prism_js3 As String
	Dim js As String
	js= File.ReadString(File.DirAssets,"prism-b4x.js")
	Return js
End Sub
Private Sub set_w3css As String
	Dim css As String
	css = File.ReadString(File.DirAssets,"w3.css")
	Return css
End Sub
